/* System-dependent definitions of various files, spool directories, etc */
/* Mods by PA0GRI */
#include "global.h"
#include "ctype.h"
#include "commands.h"
#include "netuser.h"
#include "files.h"
#include "md5.h"
#include "mailbox.h"


#if !defined(_lint) && !defined(MSDOS)
static char rcsid[] OPTIONAL = "$Id: files.c,v 1.18 1996/07/14 20:15:33 root Exp root $";
#endif

const char *Alias	  = "etc/alias";		/* the alias file */
const char *ANSIArea	  = "etc/menus/areas.bbs";	/* ANSI areas file */
const char *ANSILogin	  = "etc/menus/login.bbs";	/* ANSI login file */
const char *AreaData	  = "etc/help/areas.hlp";	/* Descriptions of message areas */
const char *AreaSlist	  = "etc/areas.sys";		/* List of message areas for sysops */
const char *CommandHelp   = "etc/help/command.hlp";	/* Command Session Help file */
const char *ConfNews	  = "etc/help/confnews.txt";	/* conference bridge news file */
const char *Dfile	  = "spool/domain.txt";		/* Domain cache */
const char *EditorHelp	  = "etc/help/editor.hlp";	/* Mini-Editor Help file */
const char *ETCdir	  = "etc";			/* the ETC direcory */
const char *Fdbase	  = "finger/dbase.dat";		/* Finger database */
const char *Fdir	  = "finger";			/* Finger info directory */
const char *FTPHelp	  = "etc/help/ftp.hlp";		/* FTP Help file */
const char *Ftpmotd	  = "etc/ftpmotd";		/* FTP message of the day */
const char *Group	  = "etc/groups";		/* the groups file */
const char *Hostfile	  = "etc/net.rc";		/* hosts and passwords */
const char *LOGdir	  = "spool/log";		/* log directory */
const char *Maillog	  = "spool/log/mail.log";	/* mail log */
const char *Mailqdir	  = "spool/mqueue";		/* Outgoing mail spool */
const char *Mailqueue	  = "spool/mqueue/*.wrk";	/* Outgoing mail work files */
const char *Mailspool	  = "spool/mail";		/* Incoming mail */
const char *MANdir	  = "man";			/* Manual pages base directory */
const char *PBBSHelp	  = "etc/help/pbbs.hlp";	/* PBBS Help file */
const char *MOTDfile	  = "etc/motd";			/* Mailbox MOTD file */
const char *MOTDsysfile   = "etc/motd.sys";		/* Mailbox MOTD file for SYSOPs */
const char *NEWUSERfile   = "etc/newuser";		/* New Pbbs User file */
const char *Onexit	  = "onexit.nos";		/* Commands to be executed on exiting */
const char *PublicDir	  = "public";			/* Public directory */
const char *Quotes	  = "etc/quotes";		/* List of quotes of the day */
const char *Rewritefile   = "etc/rewrite";		/* Address rewrite file */
const char *Routeqdir	  = "spool/rqueue";		/* queue for router */
const char *SMILEYFile	  = "etc/help/smileys.txt";	/* conf smiley file */
const char *Spool	  = "spool";			/* Spool directory */
const char *Startup	  = "autoexec.nos";		/* Initialization file */
const char *Userfile	  = "etc/ftpusers";		/* Authorized FTP users and passwords */
const char *VersionFile   = "etc/help/version.hlp";	/* Command Session version file */

#ifdef ASKHOME
const char *AskhomeFile   = "etc/askhome.dat";		/* Askhome prompt */
#endif

#ifdef BBSEXPORT
const char *EXPORTDir	  = "spool/export";		/* Export directory */
#endif

#ifdef BBSIMPORT
const char *IMPORTDir	  = "spool/import";		/* Import directory */
#endif

#ifdef CATALOG
const char *CATALOGfile   = "etc/catalog.cat";		/* String Catalog file */
#endif

#ifdef CONVERS
const char *ConfHlp	  = "etc/help/confmode.hlp";
const char *ConfInfo	  = "spool/confinfo";		/* Conferenge bridge user info */
const char *NetControlHlp = "etc/help/netcntrl.hlp";
#endif

#ifdef CRONTAB
const char *CRONTABFile	  = "spool/crontab";		/* Crontab file */
#endif

#ifdef DELEGATE
const char *DelegateFile  = "spool/mail/delegate";	/* delegation data file */
#endif

#ifdef EXPIRY
const char *Expirefile	  = "etc/expire.dat";		/* Message expiration control file */
#endif

#ifdef GPS
const char *GPSfile	  = "spool/GPSfile";		/* All heard GPS position data */
#endif

#ifdef HOLDMODS
const char *UserHoldFile  = "etc/userhold.dat";		/* file w/user name to hold mail from */
const char *WordHoldFile  = "etc/wordhold.dat";		/* file w/words to hold mail if found in */
#endif

#ifdef HTTP
const char *HTTPdir	  = "http";			/* http root directory */
#endif

#ifdef MAILBOX
const char *Helpdir	  = "etc/help";			/* Mailbox help file directory */
const char *Historyfile   = "spool/history";		/* Message ID history file */
const char *Signature	  = "spool/signatur";		/* Mail signature file directory */
#endif

#ifdef MAILCMDS
const char *Arealist	  = "etc/areas";		/* List of message areas */
#endif

#ifdef MAILFILTER
const char *FilterFile	  = "etc/mbfilter.dat";		/* Mail filter data file */
#endif

#ifdef MBFWD
const char *Forwardfile   = "etc/forward.bbs";		/* Mail forwarding file */
#endif

#ifdef NETROM
const char *Netromfile	  = "spool/netrom.sav";		/* Netrom node save file */
#endif

#if (defined(NNTP) || defined(NNTPS))
const char *Newsdir	  = "spool/nnews";		/* News messages and NNTP data */
const char *Naccess	  = "spool/nnews/access";
#endif

#ifdef NNTPS
const char *Active	  = "spool/nnews/active";	/* */
const char *Forward	  = "spool/nnews/forward";	/* */
const char *History	  = "spool/nnews/history";	/* */
const char *Nhelp	  = "spool/nnews/help";		/* */
const char *NInfo	  = "spool/nnews/info";		/* */
const char *Pointer	  = "spool/nnews/pointer";	/* */
const char *Poll	  = "spool/nnews/poll";		/* */
#endif

#if (defined(POP) || defined(POP2CLIENT) || defined(POP2SERVER) || defined(POP3CLIENT) || defined(POP3SERVER))
const char *Popusers	  = "etc/popusers";		/* POP user and password file */
#endif

#ifdef REJECT
const char *REJECTFile	  = "etc/reject.dat";		/* Message rejection file */
#endif

#ifdef STATS
const char *STATSDir	  = "spool/stats";		/* Statistics directory */
#endif

#ifdef TUTOR
const char *Info	  = "spool/info";		/* Information Center directory */
const char *News	  = "spool/news";		/* News Center directory */
const char *Tutor	  = "spool/tutor";		/* Tutorial Server directory */
const char *UCmdsHelp	  = "etc/help/usercmds.hlp";	/* BBS CMD help file */
const char *UserCmds	  = "spool/cmds";		/* BBS CMD directory */
#endif

#ifdef UNIX
const char *Config	  = "config.nos";		/* Device configuration list */
#endif

#ifdef USERLOG
const char *UDefaults	  = "spool/users.dat";		/* User preference file */
const char *UDefbak	  = "spool/users.bak";
#endif

#ifdef WPAGES
const char *WhitePages	  = "spool/wpages";		/* White Pages user log file */
const char *WhitePagesBBS = "spool/wpagebbs";		/* White Pages bbs log file */
const char *WPUpdateFile  = "spool/update.wp";		/* White Pages update temp file */
#endif

#define	SEPARATOR	'/'

#ifdef UNIX
#define ROOTDIR "."
#else
#define ROOTDIR "/"
#endif

#ifdef MSDOS
const char System[] = "MSDOS";
const char Eol[]	= "\r\n";
#endif

#ifdef TNOS_68K
const char System[] = "OSK";
const char Eol[]	= "\n";
#endif

#ifdef	UNIX
const char System[] = "UNIX";
const char Eol[]	= "\n";
const char *Command_sessmgr = "";
const char *Trace_sessmgr = "";
#endif


const char *rootdir = ROOTDIR;
static int Assigned;
int Initroot;
extern char *firstMsg;
extern char Whitespace[];

extern long btol __ARGS((char *s));

void usercvt __ARGS((void));
void undosify __ARGS((char *s));
char *getsecurity __ARGS((char *name, int32 *perms));


/* Establish a root directory other than the default. Can only be called
 * once, at startup time
 */
void
initroot(root)
char *root;
{
	if(Assigned) {
		firstMsg = strdup ("\007-f option used, -d ignored !\n");
		return;
	}
#ifdef  MSDOS
	undosify(root);
#endif
	if (root[strlen(root) - 1] == SEPARATOR)
		root[strlen(root) - 1] = 0;
	rootdir = strdup( root );

	rootdircat(&Alias);
	rootdircat(&ANSIArea);
	rootdircat(&ANSILogin);
	rootdircat(&AreaData);
	rootdircat(&AreaSlist);
	rootdircat(&CommandHelp);
	rootdircat(&ConfNews);
	rootdircat(&Dfile);
	rootdircat(&ETCdir);
	rootdircat(&EditorHelp);
	rootdircat(&Fdbase);
	rootdircat(&Fdir);
	rootdircat(&FTPHelp);
	rootdircat(&Ftpmotd);
	rootdircat(&Group);
	rootdircat(&Hostfile);
	rootdircat(&LOGdir);
	rootdircat(&Maillog);
	rootdircat(&Mailqdir);
	rootdircat(&Mailqueue);
	rootdircat(&Mailspool);
	rootdircat(&MANdir);
	rootdircat(&PBBSHelp);
	rootdircat(&MOTDfile);
	rootdircat(&MOTDsysfile);
	rootdircat(&NEWUSERfile);
	rootdircat(&Onexit);
	rootdircat(&PublicDir);
	rootdircat(&Quotes);
	rootdircat(&Rewritefile);
	rootdircat(&Routeqdir);
	rootdircat(&SMILEYFile);
	rootdircat(&Spool);
	rootdircat(&Startup);
	rootdircat(&Userfile);
	rootdircat(&VersionFile);

#ifdef ASKHOME
	rootdircat(&AskhomeFile);
#endif

#ifdef BBSEXPORT
	rootdircat(&EXPORTDir);
#endif

#ifdef BBSIMPORT
	rootdircat(&IMPORTDir);
#endif

#ifdef CATALOG
	rootdircat(&CATALOGfile);
#endif

#ifdef  CONVERS
	rootdircat(&ConfInfo);
	rootdircat(&ConfHlp);
	rootdircat(&NetControlHlp);
#endif

#ifdef CRONTAB
	rootdircat(&CRONTABFile);
#endif

#ifdef DELEGATE
	rootdircat(&DelegateFile);
#endif

#ifdef EXPIRY
	rootdircat(&Expirefile);
#endif

#ifdef GPS
	rootdircat(&GPSfile);
#endif

#ifdef HOLDMODS
	rootdircat(&UserHoldFile);
	rootdircat(&WordHoldFile);
#endif

#ifdef HTTP
	rootdircat(&HTTPdir);
#endif

#ifdef MAILBOX
	rootdircat(&Helpdir);
	rootdircat(&Historyfile);
	rootdircat(&Signature);
#endif

#ifdef MAILCMDS
	rootdircat(&Arealist);
#endif

#ifdef MAILFILTER
	rootdircat(&FilterFile);
#endif

#ifdef MBFWD
	rootdircat(&Forwardfile);
#endif

#ifdef NETROM
	rootdircat(&Netromfile);
#endif

#if (defined(NNTP) || defined(NNTPS))
	rootdircat(&Newsdir);
	rootdircat(&Naccess);
#endif

#ifdef	NNTPS
	rootdircat(&Active);
	rootdircat(&Forward);
	rootdircat(&History);
	rootdircat(&Nhelp);
	rootdircat(&NInfo);
	rootdircat(&Pointer);
	rootdircat(&Poll);
#endif

#if (defined(POP) || defined(POP2CLIENT) || defined(POP2SERVER) || defined(POP3CLIENT) || defined(POP3SERVER))
	rootdircat(&Popusers);
#endif

#ifdef REJECT
	rootdircat(&REJECTFile);
#endif

#ifdef STATS
	rootdircat(&STATSDir);
#endif

#ifdef TUTOR
	rootdircat(&Info);
	rootdircat(&News);
	rootdircat(&Tutor);
	rootdircat(&UCmdsHelp);
	rootdircat(&UserCmds);
#endif

#ifdef UNIX
	rootdircat(&Config);
#endif

#ifdef USERLOG
	rootdircat(&UDefaults);
	rootdircat(&UDefbak);
#endif

#ifdef WPAGES
	rootdircat(&WhitePages);
	rootdircat(&WhitePagesBBS);
	rootdircat(&WPUpdateFile);
#endif
	
	Initroot = 1;
}


/* Concatenate root, separator and arg strings into a malloc'ed output
 * buffer, then remove repeated occurrences of the separator char
 */
void
rootdircat(filenameptr)
char const **filenameptr;
{
char *out;
char const *filename = *filenameptr;

	if (rootdir && *rootdir)	{
		if (*filename == SEPARATOR)
			filename++;
		out = mallocw (strlen (rootdir) + strlen (filename) + 2);
		sprintf (out, "%s%c%s", rootdir, SEPARATOR, filename);
		*filenameptr =  out;
	}
}


#define lookupBUFSIZ	1024


/* Read through FTPUSERS looking for user record
 * Returns line which matches username, or NULLCHAR when no match.
 * Each of the other variables must be copied before freeing the line.
 */
char *
userlookup(username,password,directory,permission,ip_address)
const char *username;
char **password;
char **directory;
long   *permission;
uint32 *ip_address;
{
FILE *fp, *fpsave = NULLFILE;
char *buf;
char *cp = NULLCHAR;
int  wasanony = 0;
char *universal = NULLCHAR;

	if ((fp = fopen (Userfile, READ_TEXT)) == NULLFILE)
		/* Userfile doesn't exist */
		return NULLCHAR;

	buf = mallocw (lookupBUFSIZ);
	for ( ; ; )	{
		if (fgets (buf, lookupBUFSIZ - 1, fp) == NULLCHAR)	{
			if (fpsave)	{
				fclose (fp);
				fp = fpsave;
				fpsave = NULLFILE;
				continue;
			}
			break;
		}
		if (!strnicmp (buf, "#include", 8))	{
			rip (buf);
			cp = skipwhite (&buf[8]);
			fpsave = fp;
			if((fp = fopen (cp, READ_TEXT)) == NULLFILE)	{
				fp = fpsave;
				fpsave = NULLFILE;
			}
			continue;
		}
		if (*buf == '#')
			continue;	/* Comment */

		if ((cp = strpbrk (buf, " \t")) == NULLCHAR)
			/* Bogus entry */
			continue;
		*cp++ = '\0';		/* Now points to password */
		cp = skipwhite (cp);	/* It does now... KFU */

		if (stricmp (username, buf) == 0)
			break;		/* Found user */
		if (stricmp ("univperm", buf) == 0)
			universal = strdup (cp);	/* remember their anon entry */
	}
	if (feof (fp))	{
		if (universal == NULLCHAR)	{
			/* username not found in file, nor was univperm */
			if (fpsave)
				fclose (fpsave);
			fclose (fp);
			free (buf);
			return NULLCHAR;
		}
		/* restore anonymous to the buffer */
		strcpy (cp = buf, universal);
		wasanony = 1;
	}
	if (universal != NULLCHAR)
		free (universal);
	fclose (fp);
	if (fpsave)
		fclose (fpsave);

	if (cp == NULLCHAR)
		return cp;

	if (password != NULL)
		*password = cp;

	/* Look for space or tab after password field in file */
	if ((cp = strpbrk (cp, " \t")) == NULLCHAR)	{
		/* Invalid file entry */
		free (buf);
		return NULLCHAR;
	}
	*cp++ = '\0';	/* Now points to directory field */
	cp = skipwhite (cp);

	if (*cp == '#')		{ /* using a security level entry */
		char *cp2, *path;
		int32 perm = 0;
		rip (cp);
		if ((cp2 = strpbrk (++cp, " \t")) != NULLCHAR)
			*cp2++ = 0;
		path = getsecurity (cp--, &perm);
		if (path != NULLCHAR)
			sprintf(cp, "%s %ld", path, perm);
	}
	if (directory != NULL)
		*directory = cp;

	if ((cp = strpbrk (cp, " \t")) == NULLCHAR)	{
		/* Permission field missing */
		free (buf);
		return NULLCHAR;
	}
	*cp++ = '\0';	/* now points to permission field */
	cp = skipwhite (cp);

	if (permission != NULL)	{
		if (!strnicmp (cp, "0x", 2))
			*permission = htol (cp);
		else if (*cp == '%')
			*permission = btol (cp);
		else
			*permission = atol (cp);
		if (wasanony)
			*permission |= WAS_ANONY;

		if (*permission & NO_SENDCMD)
			*permission |= (NO_PBBSMAIL + NO_INETMAIL + NO_AMPRMAIL);

	}

	if ((cp = strpbrk (cp, " \t")) == NULLCHAR)	{
		/* IP address missing */
		if (ip_address != NULL)
			*ip_address = 0L;
	} else {
		*cp++ = '\0';	/* now points at IP address field */
		cp = skipwhite (cp);
		if (ip_address != NULL)
			*ip_address = resolve(cp);
	}
	return buf;
}


/* Subroutine for logging in the user whose name is name and password is pass.
   The buffer path should be long enough to keep a line from the userfile.
   If pwdignore is true, the password check will be overridden.
   The return value is the permissions field or -1 if the login failed.
   Path is set to point at the path field, and pwdignore will be true if no
   particular password was needed for this user.
 */
long
userlogin(name,pass,path,len,pwdignore)
const char *name;
char *pass;
char **path;
int len;			/* Length of buffer pointed at by *path */
int *pwdignore;
{
char *buf;
char *password;
char *directory;
long permission;
int anonymous;
char *cp;
char hashpass[16];
MD5_CTX md;

	if ((buf = userlookup (name, &password, &directory,
		&permission, NULL)) == NULLCHAR)
			return -1;

	anonymous = *pwdignore;
	if (strcmp (password, "*") == 0)
		anonymous = TRUE;	/* User ID is password-free */
	if (!anonymous) {
		if (readhex (hashpass, password, sizeof (hashpass)) != (int) sizeof (hashpass)){
			/* Invalid hashed password in file */
			free (buf);
			return -1;
		}
		MD5Init (&md);
		MD5Update (&md, (const unsigned char *) name, strlen (name));
		MD5Update (&md, (unsigned char *) pass, strlen (pass));
		MD5Final (&md);
		if (memcmp (md.digest, hashpass, sizeof (hashpass)) != 0){
			/* Incorrect password given */
			free (buf);
			return -1;
		}
	}
	if ((int)strlen(directory) + 1 > len) {
		/* not enough room for path */
		free (buf);
		return -1;
	}

#if   defined(AMIGA)
	/*
	 * Well, on the Amiga, a file can be referenced by many names:
	 * device names (DF0:) or volume names (My_Disk:).  This hunk of code
	 * passed the pathname specified in the ftpusers file, and gets the
	 * absolute path copied into the user's buffer.  We really should just
	 * allocate the buffer and return a pointer to it, since the caller
	 * really doesn't have a good idea how long the path string is..
	 */
	if ((directory = pathname ("", directory)) != NULLCHAR) {
		strcpy (*path, directory);
		free (directory);
	} else
		**path = '\0';
#else
	strcpy (*path, directory);
	/* Convert any backslashes to forward slashes, for backward
	 * compatibility with the old NET
	 */
	while ((cp = strchr (*path, '\\')) != NULLCHAR)
		*cp = '/';
#endif
	free (buf);
	*pwdignore = anonymous;
	/* Finally return the permission bits */
	return permission;
}


/* MD5 hash plaintext passwords in a file */
static void
usercvtfile(const char *file, int recursing)
{
FILE *fp,*fptmp;
char *buf, *cp;
char hexbuf[16];
int needsit = 0;
int len,nlen,plen,i;
char *pass;
MD5_CTX md;

	if ((fp = fopen (file, READ_TEXT)) == NULLFILE)
		return;		/* file doesn't exist */

	tprintf ("%sEncoding passwords in %s\n", (recursing) ? "" : "\n", file);
	buf = mallocw (BUFSIZ);
	while (fgets (buf, BUFSIZ, fp) != NULLCHAR){
		rip (buf);
		len = (int) strlen (buf);
		if (len == 0)
			continue;	/* Blank line */

		if (!strnicmp (buf, "#include", 8))	{
			cp = skipwhite (&buf[8]);
			usercvtfile (cp, 1);
			continue;
		}
		if (*buf == '#')
			continue;	/* Comment line */

		if ((nlen = (int) strcspn (buf,Whitespace)) == len)
			continue;	/* No end to the name! */

		/* Skip whitespace between name and pass */
		for (pass = &buf[nlen]; isspace (*pass); pass++)
			;
		if(*pass != '\0' && *pass != '*'
		 && readhex (hexbuf, pass, sizeof (hexbuf)) != 16){
			needsit = 1;
			break;
		}
	}
	if(!needsit){
		/* Everything is in order */
		fclose (fp);
		free (buf);
		return;
	}
	/* At least one entry needs its password hashed */
	rewind (fp);
	fptmp = tmpfile();
	if (fptmp == NULLFILE)	{
		printf ("Can't rewrite %s: can't create a tempfile!\n", file);
		fclose (fp);
		free (buf);
		return;
	}
	while (fgets (buf, BUFSIZ, fp) != NULLCHAR)	{
		rip (buf);
		if ((len = (int) strlen (buf)) == 0 || *buf == '#'
		 || (nlen = (int) strcspn (buf, Whitespace)) == len){
			/* Line is blank, a comment or unparseable;
			 * copy unchanged
			 */
			fputs (buf, fptmp);
			fputc ('\n', fptmp);
			continue;
		}
		/* Skip whitespace between name and pass */
		for (pass = &buf[nlen]; isspace (*pass); pass++)
			;

		if(*pass == '\0' || *pass == '*'
		 || (plen = (int) strcspn (pass, Whitespace)) == (int)strlen (pass)
		 || readhex (hexbuf, pass, sizeof (hexbuf)) == (int)sizeof (hexbuf)){
			/* Other fields are missing, no password is required,
			 * or password is already hashed; copy unchanged
			 */
			fputs (buf, fptmp);
			fputc ('\n', fptmp);
			continue;
		}
		MD5Init (&md);
		MD5Update (&md, (unsigned char *) buf, (unsigned int)nlen);	/* Hash name */
		MD5Update (&md, (unsigned char *) pass, (unsigned int)plen);	/* Hash password */
		MD5Final (&md);
		fwrite (buf, 1, (unsigned int)nlen, fptmp);	/* Write name */
		fputc (' ', fptmp);		/* and space */
		for (i = 0; i < 16; i++)	/* Write hashed password */
			fprintf (fptmp, "%02x", md.digest[i] & 0xff);
		fputs (&pass[plen], fptmp);	/* Write remainder of line */
		fputc ('\n', fptmp);
	}
	/* Now copy the temp file back into the userfile */
	fclose (fp);
	rewind (fptmp);
	if ((fp = fopen (file, WRITE_TEXT)) == NULLFILE)	{
		printf ("Can't rewrite %s\n", file);
		free (buf);
		return;
	}
	while (fgets (buf, BUFSIZ, fptmp) != NULLCHAR)
		fputs (buf, fp);
	fclose (fp);
	fclose (fptmp);
	free (buf);
}


/* MD5 hash plaintext passwords in user file */
void
usercvt()
{
	usercvtfile (Userfile, 0);
}



static const char * DFAR Files[] = {
	"Startup", "Userfile", "Hostfile", "Maillog", "Mailspool", "Mailqdir",
	"Mailqueue", "Routeqdir", "Alias", "Group", "Dfile", "Fdir", "Fdbase",
	"Quotes", "Tutor", "Info", "News", "Spool", "Arealist", "AreaSlist",
	"Rewritefile", "Signature", "Historyfile", "Helpdir", "UDefaults",
	"UDefbak", "Popusers", "Newsdir", "Forwardfile", "Netromfile",
	"Onexit", "Expirefile", "FTPHelp", "Ftpmotd", "EditorHelp",
	"MOTDfile", "MOTDsysfile", "NEWUSERfile", "WhitePagesBBS",
	"WhitePages", "ConfInfo", "ConfHlp", "NetControlHlp", "Active",
	"Pointer", "NInfo", "Nhelp", "History", "Forward", "Poll",
	"PBBSHelp", "CommandHelp", "GPSfile", "ANSIArea", "ANSILogin",
	"SMILEYFile", "ConfNews", "VersionFile", "Command", "Trace",
	"DelegateFile", "UserCmds", "UCmdsHelp", "FilterFile",
	"PublicDir", "AskhomeFile", "AreaData", "UserHoldFile",
	"WordHoldFile", "IMPORTDir", "EXPORTDir", "STATSDir", "WPUpdateFile",
	"CATALOGfile", "ETCdir", "LOGdir", "CRONTABFile", "HTTPdir",
	"MANdir", "REJECTFile", "Naccess", NULLCHAR
};


void setname(name, file)
char *name, *file;
{
const char **this = (const char **)0;
int k;

	for (k = 0; Files[k] != NULLCHAR; k++)	{
		if (!stricmp (Files[k], name))
			break;
	}
	if (Files[k] == NULLCHAR)
		return;
	switch (k)	{
		case 0:		this = &Startup;	break;
		case 1:		this = &Userfile;	break;
		case 2:		this = &Hostfile;	break;
		case 3:		this = &Maillog;	break;
		case 4:		this = &Mailspool;	break;
		case 5:		this = &Mailqdir;	break;
		case 6:		this = &Mailqueue;	break;
		case 7:		this = &Routeqdir;	break;
		case 8:		this = &Alias;		break;
		case 9:		this = &Group;		break;
		case 10:	this = &Dfile;		break;
		case 11:	this = &Fdir;		break;
		case 12:	this = &Fdbase;		break;
		case 13:	this = &Quotes;		break;
#ifdef TUTOR
		case 14:	this = &Tutor;		break;
		case 15:	this = &Info;		break;
		case 16:	this = &News;		break;
#endif
		case 17:	this = &Spool;		break;
#ifdef MAILCMDS
		case 18:	this = &Arealist;	break;
#endif
		case 19:	this = &AreaSlist;	break;
		case 20:	this = &Rewritefile;	break;
#ifdef MAILBOX
		case 21:	this = &Signature;	break;
		case 22:	this = &Historyfile;	break;
		case 23:	this = &Helpdir;	break;
#ifdef USERLOG
		case 24:	this = &UDefaults;	break;
		case 25:	this = &UDefbak;	break;
#endif
#endif
#if (defined(POP) || defined(POP2CLIENT) || defined(POP2SERVER) || defined(POP3CLIENT) || defined(POP3SERVER))
		case 26:	this = &Popusers;	break;
#endif
#if (defined(NNTP) || defined(NNTPS))
		case 27:	this = &Newsdir;	break;
#endif
#ifdef MBFWD
		case 28:	this = &Forwardfile;	break;
#endif
#ifdef NETROM
		case 29:	this = &Netromfile;	break;
#endif
		case 30:	this = &Onexit;		break;
#ifdef EXPIRY
		case 31:	this = &Expirefile;	break;
#endif
		case 32:	this = &FTPHelp;	break;
		case 33:	this = &Ftpmotd;	break;
		case 34:	this = &EditorHelp;	break;
		case 35:	this = &MOTDfile;	break;
		case 36:	this = &MOTDsysfile;	break;
		case 37:	this = &NEWUSERfile;	break;
#ifdef WPAGES
		case 38:	this = &WhitePagesBBS;	break;
		case 39:	this = &WhitePages;	break;
#endif
#ifdef  CONVERS
		case 40:	this = &ConfInfo;	break;
		case 41:	this = &ConfHlp;	break;
		case 42:	this = &NetControlHlp;	break;
#endif
#ifdef NNTPS
		case 43:	this = &Active;		break;
		case 44:	this = &Pointer;	break;
		case 45:	this = &NInfo;		break;
		case 46:	this = &Nhelp;		break;
		case 47:	this = &History;	break;
		case 48:	this = &Forward;	break;
		case 49:	this = &Poll;		break;
#endif
		case 50:	this = &PBBSHelp;	break;
		case 51:	this = &CommandHelp;	break;
#ifdef GPS
		case 52:	this = &GPSfile;	break;
#endif
		case 53:	this = &ANSIArea;	break;
		case 54:	this = &ANSILogin;	break;
		case 55:	this = &SMILEYFile;	break;
		case 56:	this = &ConfNews;	break;
		case 57:	this = &VersionFile;	break;
#ifdef UNIX
		case 58:	this = &Command_sessmgr;break;
		case 59:	this = &Trace_sessmgr;	break;
#endif
#ifdef DELEGATE
		case 60:	this = &DelegateFile;	break;
#endif
#ifdef TUTOR
		case 61:	this = &UserCmds;	break;
		case 62:	this = &UCmdsHelp;	break;
#endif
#ifdef MAILFILTER
		case 63:	this = &FilterFile;	break;
#endif
		case 64:	this = &PublicDir;	break;
#ifdef ASKHOME
		case 65:	this = &AskhomeFile;	break;
#endif
		case 66:	this = &AreaData;	break;
#ifdef HOLDMODS
		case 67:	this = &UserHoldFile;	break;
		case 68:	this = &WordHoldFile;	break;
#endif
#ifdef BBSIMPORT
		case 69:	this = &IMPORTDir;	break;
#endif
#ifdef BBSEXPORT
		case 70:	this = &EXPORTDir;	break;
#endif
#ifdef STATS
		case 71:	this = &STATSDir;	break;
#endif
#ifdef WPAGES
		case 72:	this = &WPUpdateFile;	break;
#endif
#ifdef CATALOG
		case 73:	this = &CATALOGfile;	break;
#endif
		case 74:	this = &ETCdir;		break;
		case 75:	this = &LOGdir;		break;
#ifdef CRONTAB
		case 76:	this = &CRONTABFile;	break;
#endif
#ifdef HTTP
		case 77:	this = &HTTPdir;	break;
#endif
		case 78:	this = &MANdir;		break;
#ifdef REJECT
		case 79:	this = &REJECTFile;	break;
#endif
#if (defined(NNTP) || defined(NNTPS))
		case 80:	this = &Naccess;	break;
#endif
		default:	break;
	}
	if (this != (const char **)0)	{
		if (Initroot)
			free (*this);
		*this = strdup (file);
	}
}


#define BUFLEN 128

void
assign_filenames(config, verbose)
const char *config;
int verbose;
{
FILE *fp;
char *name,*file,*cp;
int line;
char buf[BUFLEN+1];
char buf2[BUFLEN+1];

	strcpy (buf, config);
	undosify (buf);
	if ((fp = fopen (buf, "r")) == NULL) {
		if (verbose)	{
			sprintf (buf2, "Cannot open '%s'\n", buf);
			firstMsg = strdup (buf2);
		}
		return;
	}

	line = 0;
	while (fgets (buf, BUFLEN, fp) != NULL) {
		line++;
		if (*buf == '#')         /* comment */
			continue;
		rip (buf);   /* delete ending \n */
		name = skipwhite (buf);
		if (*name == '\0')      /* blank line */
			continue;
		/* Search for filename */
		if ((file = strchr (name, '=')) == NULL) {
			printf ("Need '=', line %d of %s.\n", line, config);
			continue;
		}
		*file++ = '\0';
		/* cut trailing spaces */
		if ((cp = strchr (name,' ')) != NULL)
			*cp = '\0';

		/* find start of filename */
		file = skipwhite (file);

		if (*file == '\0')
			continue;

		/* cut trailing spaces */
		if ((cp = strchr (file, ' ')) != NULL)
			*cp = '\0';

		/* Now parse the name, and assign if valid */
		setname (name, file);
	}
	fclose (fp);
	Assigned = 1;
}


