#ifndef _FORWARD_H
#define _FORWARD_H

#ifndef _MAILBOX_H
#include "mailbox.h"
#endif

#ifndef _FWDPARSE_H
#include "fwdparse.h"
#endif

/* Defines for the ax.25 forwarding code           */
/* This was moved from the mailbox.h include file. */

/* In forward.c: */
int dorevfwd __ARGS((int argc,char *argv[],void *p));
int dombtimer __ARGS((int argc,char *argv[],void *p));
int dombkick __ARGS((int argc,char *argv[],void *p));
char *fwd_bbsname __ARGS((struct mbx *m));
int fwdinit __ARGS((struct mbx *m, int try));
void mark_forwarded __ARGS((FILE *fp,long ind, char thetype));
int makecl __ARGS((struct mbx *m,int msgn,char *dest,char *line,char *subj,char *bid,int *bul));
void sendmsg __ARGS((struct mbx *m,int msgn,char *thebid));
int checksubchannel __ARGS((struct mbx *m, int assignit));
void releasesubchannel __ARGS((struct mbx *m));

/* In fbbfwd.c: */
int dofbbfwd __ARGS((int argc,char *argv[],void *p));

/* In xfwd.c: */
int doxfwd __ARGS((int argc,char *argv[],void *p));

/* In smtpserv.c: */
void statusCtl __ARGS((const char *who, const char *extension,struct let *info,int entry, int readit));


#ifdef FBBFWD

#define fbbUNKNOWN 0
#define fbbNO      1
#define fbbYES     2
#define fbbDEFER   3

#define FBBMAXMSGS 5             /* Maximum number of messages to process for FBB. */
#define XMAXMSGS   25            /* Maximum number of messages to process for X-fwding. */


/* FBB Packet   */
struct fbbpacket {
     int    number;          /* Message number in mail area.                   */
     int    accept;          /* NotActive = 0 / Reject(-) = 1                  */
                             /* Accept(+) = 2 / Defer(=)  = 3                  */
#ifdef REJECT
     int    reject;	     /* value returned from reject()		       */
#endif
     char   fbbcmd[3];       /* FB ( FA when compression is added )            */
     char   type;            /* (B)ulletin, (P)ersonal, (T)raffic/NTS          */
     char   bid[15];         /* Hold makecl() modified bid.                    */
     char   *sline;          /* bufptr that holds the bbs send command         */
                             /* used to enter a message onto the system.       */
     char   *rewrite_to;     /* Place to keep the new, ( via rewrite() to info */
     char   *to;
     char   *from;
     char   *messageid;
     char   *area;
     char   *subject;
     int    size;
     FILE   *fwdfile;
     long   fwdfilesize;
     long   fwdfileindex;
};

/* A forward entry */
struct fwd {
    struct mbx *m;
    char bid[15];
    char subject[80];
    FILE *fwdfile;
    long fwdfileindex;
#ifdef FBBFWD
    char                *tmpBuffer;
    struct fbbpacket    *msglst;
    char                savefsline[MBXLINE+1];
    char                line[MBXLINE+1];
    char                iFile[132];
    char                oFile[132];
    struct lzhufstruct  *lzhuf;
#endif
#ifdef XFWD
    char		numtrans;
#endif
};

#endif


/* A Forwarding BBS */
struct bbs      {
        char	name[FWDBBSLEN];
        char	processed;
        char	subchannel;
        time_t	laston;
        time_t	lastactivity;
};


/* A subchannel structure */
struct subchan {
	int	limit;
	int	used;
	char	*description;
};

extern struct subchan *subchannels;


#ifdef FBBCMP
#include "lzhuf.h"
#endif

#if defined(XFWD) || defined(FBBFWD)
extern int FWDareatrace;
#endif

#ifdef ALTERBID
extern int chkBidAltered, holdBidAltered;
#endif

#endif  /* FORWARD_H */
