#ifndef	_CONFIG_H
#define	_CONFIG_H

/* This is a test configuration to iron out conditional errors N8FOW */

#undef BETA		1	/* beta-test version */


/* BBS Specific options */
#define	MAILBOX		1	/* Include SM0RGV mailbox server */
#undef  MAILFOR		1	/* Include Mailbox 'Mail for' beacon */
#undef  RLINE		1	/* Include BBS R:-line interpretation code */
#undef  MBFWD		1	/* Include Mailbox AX.25 forwarding */
#undef  USERLOG		1	/* Include last-message-read tracking for users */
#undef  ASKHOME		1	/* ask new user for home BBS? */
#undef  WPAGES		1	/* White Pages support */
#undef  FBBFWD		1	/* FBB Forwarding code (no compression) */
#undef  FBBCMP		1	/* FBB Compressed forwarding code. */
#undef  MBXTDISC	1	/* Include mailbox timeout-disconnect */
#undef  EXPIRY		1	/* Include message and bid expiry */
#undef  TIPMAIL		1	/* Include TIP mailbox server */
#undef  XMODEM		1	/* xmodem file xfer for tipmail  */
#undef  DELEGATE	1	/* Include mail forwarding "delegation" server */
#undef  CALLBOOK	1	/* Simple (older) callbook server over Internet */
#undef  CALLCLI		1	/* An improved, generic IP callbook client */
#undef  AX25PASSWORD	1	/* Ask ax.25 users for their passwords */
#undef  BBSIMPORT	1	/* Include PBBS import file support */
#undef  BBSEXPORT	1	/* Include PBBS export file support */
#undef  PING_SECURE	1	/* Allow ping BBS command from only those who can telnet */
#define MAILCMDS	1	/* Include mail commands, S, R, V etc */
#undef  FILECMDS	1	/* Include D,U,W,Z commands */
#undef  GATECMDS	1	/* Include gateway releated commands C,E,N,NR,P,PI,T */
#undef  FOQ_CMDS	1	/* Include Finger, Operator, Query
				 * If GATECMDS and FOQ_CMDS are both undefined,
				 * extra code is saved! */


/* Mail Specific options - SMTP, POP, POP2, POP3 or BBS */
#undef  RMAIL		1	/* RMAIL support */
#undef  REQSVR		1	/* REQSVR support */
#undef 	POP		1	/* Include POP2 Post Office Protocol */
#undef 	POP2CLIENT	1	/* POP2 client -- IAB not recommended */
#undef 	POP2SERVER	1	/* POP2 server -- IAB not recommended */
#undef 	POP3CLIENT	1	/* POP3 client -- IAB draft standard */
#undef  POP3SERVER	1	/* POP3 server -- IAB draft standard */
#undef  TRANSLATE	1	/* incoming 'from' translation */
#undef  MAILFILTER	1	/* enable mail filtering */
#undef  HOLDMODS	1	/* enable word/address scanning */
#undef  HOPPER		1	/* Include SMTP hopper code by G8FSL */


/* Options related to assorted servers */
#define SERVERS		1	/* Include TCP servers */
#undef  DSERVER		1	/* Include Domain Name Server */
#undef  TUTOR		1	/* Tutorial Server */
#undef  RDATE		1	/* Include the Time Protocol */


/* Protocol Specific options */
#undef  SLIP		1	/* Serial line IP on built-in ports */
#undef  PPP		1	/* Point-to-Point Protocol code */
#undef  VJCOMPRESS	1	/* Van Jacobson TCP compression for SLIP */
#undef  DIALER		1	/* SLIP redial code */
#undef  RIP		1	/* Include RIP routing */
#undef  RSPF		1	/* Include Radio Shortest Path First Protocol */
#undef  RARP		1	/* Include Reverse Address Resolution Protocol */


/* NETROM specific options */
#undef  NRS		1	/* NET/ROM async interface */
#undef  NETROM		1	/* NET/ROM network support */
#undef  NR4TDISC	1	/* Include Netrom L4 timeout-disconnect */


/* Routing, tracing and security options */
#undef  AXIP		1	/* digipeater via ip port 93 interface */
#undef  TRACE		1	/* Include packet tracing code */
#undef  MONITOR		1	/* Include user-port monitor trace mode */
#undef  IPACCESS	1	/* Include IP access control code */
#undef  TCPACCESS	1	/* Include TCP access control code */
#undef  ENCAP		1	/* Include IP encapsulation code */
#undef  AUTOROUTE	1	/* Include AX.25 IP auto-route code(causes problems when VC mode is used for ip) */
#undef  HOPCHECK	1	/* IP path tracing command */
#undef  TCPGATE		1	/* TCP gateway server */
#undef  LOOKSESSION	1	/* Include sysop look code */
#undef  RXECHO		1	/* Echo rx packet to another iface - WG7J */
#undef  TRACESERVER	1	/* Enable trace server */


/* MSDOS Specific options - do not use with Linux! */
#undef 	SWATCH		1	/* Programmer's debugging stopwatch feature */
#undef 	STKTRACE	1	/* Include stack tracing code */
#undef 	XSPAWN		1	/* Include swapping to ems or disk on spawning shell */
#undef 	MULTITASK	1	/* Include Dos shell multi-tasker */
#undef 	SAMCALLB	1	/* SAM callbook support */
#undef 	CALLSERVER	1	/* Include BuckMaster CDROM server support */
#undef  UMB		1	/* Include UMB access code */


/* Linux Specific options - do not use with MSDOS! */
#define SM_CURSES	1	/* curses session manager */
#define SM_DUMB		1	/* dumb session manager */
#undef 	SM_RAW		1	/* raw terminfo session manager */
#undef  UNIX_SOCKETS	1	/* allow attach of remote TCP port as async dev */


/* Statistics options */
#undef  STATS		1	/* include statistics */
#undef  STATS_USE	1	/* include usage statistics */
#undef  STATS_MSG	1	/* include message statistics */
#undef  STATS_AREA	1	/* include area statistics */
#undef  STATS_FWD	1	/* include forwarding statistics */
#undef  STATS_TFC	1	/* include traffic statistics */


/* Reserved for future use - probably not functional or soon to be removed */
#define DOS_GETFILEATTR	1	/* must be completed for unix version */
#undef 	GPS		1	/* GPS position support */


/* Assorted Software options */
#undef  SCRIPTING	1	/* include Command Session scripting commands */
#undef  QRZCALLB	1	/* Include QRZ callbook support */
#undef  POOLED		1	/* use POOLED allocations where possible */
#undef  VERSION_ON_FILE	1	/* Version command reads file */
#undef  SCREENSAVER	1	/* Local screen saver */
#undef  ESCAPE		1	/* Allow Unix style escape on PC */
#undef  CONVERS		1	/* Conference bridge (babble-box :-) */
	/* Use only ONE of the 2 news options below !!! */
#undef 	NNTP		1	/* Netnews client */
#undef 	NNTPS		1	/* Netnews client and server */
#undef  LZW		1	/* LZW-compressed sockets */
#undef  RLOGINCLI	1	/* Rlogin client code */
#undef  RLOGINSERV	1	/* Rlogin server code */
#undef  ATCMD		1	/* Include timed 'at' execution */
#undef  FTPTDISC	1	/* Include ftp-server timeout disconnect */
#undef  LOCK		1	/* Include keyboard locking */
#undef  TTYCALL		1	/* Include AX.25 ttylink call */
#undef  AXBCSTR		1	/* Include "ax bc <if> <str>" */
#undef  AXUI		1	/* Include AX UI client */
#undef  SHELL		1	/* Include shell command */
#define ALLSESSIONS	1	/* Include all session types */
	/*if undefined, deletes outgoing telnet,ftp,ax25,netrom sessions */
#define ALLCMD     1    /* if undefined, exclude a bunch of commands */
	/*excluded are:
	 *   delete,rename,more,tail,dump,status,motd,cd,dir,finger,fkey
	 *   info,mail,mkdir,pwd,record,rmdir,watch,test,upload
	 */
#define ALLSERV      1   /* if undefined, exclude a bunch of servers */
	/*excluded are:
	 *echo,discard,daytime,time,tip and ttylink servers
	 *and the ttylink command (with no split screen code anymore)
	 */


/* Software tuning parameters */
#define MTHRESH		16384	/* Default memory threshold */
#define NROWS		25	/* Number of rows on screen */
#define NIBUFS		10	/* Number of interrupt buffers */
#define IBUFSIZE	1024	/* Size of interrupt buffers */
#define NSESSIONS	10	/* Number of interactive clients */
#define DEFNSOCK	60 	/* Default number of sockets */


/* Generic Hardware driver options */
#define KISS		1	/* KISS TNC code */
#define ASY		1	/* Asynch driver code */


/* MSDOS Specific Hardware driver options - do not use with Linux! */
#undef 	ARCNET		1	/* ARCnet via PACKET driver */
#undef 	PC_EC		1	/* 3-Com 3C501 Ethernet controller */
#undef 	HS		1	/* High speed (56kbps) modem driver */
#undef 	HAPN		1	/* Hamilton Area Packet Network driver code */
#undef 	EAGLE		1	/* Eagle card driver */
#undef 	PACKET		1	/* FTP Software's Packet Driver interface */
#undef 	PC100		1	/* PAC-COM PC-100 driver code */
#undef 	APPLETALK	1	/* Appletalk interface (Macintosh) */
#undef 	DRSI		1	/* DRSI PCPA slow-speed driver */
#undef 	SCC		1	/* PE1CHL generic scc driver */
#undef 	PI		1	/* VE3IFB pi dma card scc driver */
#undef 	SLFP		1	/* SLFP packet driver class supported */


#include "config.chk"

#endif	/* _CONFIG_H */
