/* Mods by PA0GRI */
#ifndef	_SOCKET_H
#define	_SOCKET_H

#ifndef	_GLOBAL_H
#include "global.h"
#endif

#if defined(ANSIPROTO) && !defined(_STDARG_H)
#include <stdarg.h>
#endif

#ifndef	_MBUF_H
#include "mbuf.h"
#endif

#ifndef _PROC_H
#include "proc.h"
#endif

#ifndef _SOCKADDR_H
#include "sockaddr.h"
#endif

/* Local IP wildcard address */
#ifndef INADDR_ANY
#define	INADDR_ANY	0x0L
#endif

/* IP protocol numbers */
/* now in internet.h */

/* TCP port numbers */
#define	IPPORT_ECHO	7	/* Echo data port */
#define	IPPORT_DISCARD	9	/* Discard data port */
#define	IPPORT_DAYTIME	13	/* Daytime data port */
#define IPPORT_QUOTE	17	/* Quote of the day port */
#define	IPPORT_FTPD	20	/* FTP Data port */
#define	IPPORT_FTP	21	/* FTP Control port */
#define IPPORT_TELNET	23	/* Telnet port */
#define IPPORT_SMTP	25	/* Mail port */
#define	IPPORT_TIME	37	/* Time data port */
#define IPPORT_TFTPD    69	/* TFTP data port */
#define	IPPORT_FINGER	79	/* Finger port */
#define IPPORT_HTTP	80	/* HTTP port */
#define	IPPORT_TTYLINK	87	/* Chat port */
#define	IPPORT_POP	109	/* Pop port */
#define	IPPORT_POP2	109	/* Pop port */
#define IPPORT_POP3	110	/* Pop port */
#define IPPORT_NNTP	119	/* Netnews port */
#define	IPPORT_RLOGIN	513	/* Remote login */
#define IPPORT_CALLDB	1235	/* Pulled out of the air GRACILIS */
#define IPPORT_TRACE	1236	/* Pulled out of the air - WG7J */
#define IPPORT_NEWS     3597    /* News Tutorial */
#define IPPORT_INFO     3598    /* Info Tutorial */
#define IPPORT_TUTOR    3599    /* Tutorial */
#define	IPPORT_CONVERS	3600	/* Converse */
#define IPPORT_XCONVERS 3601    /* LZW Convers */
#define IPPORT_TERM	5000	/* Serial interface server port */
#define IPPORT_X	7388	/* X server control port (out of the air) */

/* UDP port numbers */
#define	IPPORT_DOMAIN	53
#define	IPPORT_BOOTPS	67	/* bootp server */
#define	IPPORT_BOOTPC	68	/* bootp client */
#define	IPPORT_RWHO	513
#define	IPPORT_RIP	520
#define	IPPORT_TIMED	525	/* Time daemon */
#define	IPPORT_REMOTE	1234	/* Pulled out of the air */

#define	AF_INET		0
#define	AF_AX25		1
#define AF_NETROM	2
#define	AF_LOCAL	3

#define	SOCK_STREAM	0
#define	SOCK_DGRAM	1
#define	SOCK_RAW	2
#define SOCK_SEQPACKET	3

/* Socket flag values - controls newline mapping */
#define	SOCK_BINARY	0	/* socket in raw (binary) mode */
#define	SOCK_ASCII	1	/* socket in cooked (newline mapping) mode */
#define	SOCK_QUERY	2	/* Return setting without change */

/* Socket noblock values, set with sockblock() */
#define SOCK_BLOCK      0
#define SOCK_NOTXBLOCK  1
#define SOCK_NORXBLOCK  2


#ifdef UNIX

/*
 * Avoid collisions with the C library's socket interface.  We may want to use
 * that in the future, anyway.  (Something like WAMPES tcpgate, but with some
 * protections.)
 */

#define accept j_accept
#define bind j_bind
#define connect j_connect
#define getpeername j_getpeername
#define getsockname j_getsockname
#define listen j_listen
#define setflush j_setflush
#define shutdown j_shutdown
#define socket j_socket
#define socketpair j_socketpair
#define recv j_recv
#define recvfrom j_recvfrom
#define send j_send
#define sendto j_sendto

#define EABORT ECONNRESET
#ifdef linux
#define EALARM ETIME
#else
#define EALARM ETIMEDOUT
#endif

#else

#undef EMFILE
#define	EMFILE	1
#undef EBADF
#define	EBADF	2
#undef EINVAL
#define	EINVAL	3
#define	ESOCKTNOSUPPORT	4
#define	EAFNOSUPPORT	5
#define	EOPNOTSUPP	6
#undef EFAULT
#define	EFAULT		7
#define	ENOTCONN	8
#define	ECONNREFUSED	9
#define EAFNOSUPP	10
#define	EISCONN		11
#define	EWOULDBLOCK	12
#undef EINTR
#define	EINTR		13
#define	EADDRINUSE	14
#undef ENOMEM
#define	ENOMEM		15
#define EMSGSIZE	16
#define	EALARM		17
#define	EABORT		18

#endif

/* In socket.c: */
extern int Axi_sock;	/* Socket listening to AX25 (there can be only one) */

int accept __ARGS((int s,char *peername,int *peernamelen));
int bind __ARGS((int s,char *name,int namelen));
int close_s __ARGS((int s));
int connect __ARGS((int s,char *peername,int peernamelen));
void freesock __ARGS((struct proc *pp));
int getpeername __ARGS((int s,char *peername,int *peernamelen));
int getsockname __ARGS((int s,char *name,int *namelen));
int listen __ARGS((int s,int backlog));
int recv_mbuf __ARGS((int s,struct mbuf **bpp,int flags,char *from,int *fromlen));
int send_mbuf __ARGS((int s,struct mbuf *bp,int flags,char *to,int tolen));
int setflush __ARGS((int s,int c));
int shutdown __ARGS((int s,int how));
int socket __ARGS((int af,int type,int protocol));
void sockinit __ARGS((void));
int sockkick __ARGS((int s));
int socklen __ARGS((int s,int rtx));
struct proc *sockowner __ARGS((int s,struct proc *newowner));
int usesock __ARGS((int s));
int socketpair __ARGS((int af,int type,int protocol,int sv[]));
int socketalive __ARGS((int s));

/* In sockuser.c: */
void flushsocks __ARGS((void));
int keywait __ARGS((const char *prompt,int flush));
int recv __ARGS((int s,char *buf,int len,int flags));
int recvchar __ARGS((int s));
int recvfrom __ARGS((int s,char *buf,int len,int flags,char *from,int *fromlen));
int nb_recvline __ARGS((int s,unsigned char *buf,unsigned len));
int recvline __ARGS((int s,unsigned char *buf,unsigned len));
int rrecvchar __ARGS((int s));
int send __ARGS((int s,char *buf,int len,int flags));
int sendto __ARGS((int s,char *buf,int len,int flags,char *to,int tolen));
int seteol __ARGS((int s,const char *seq));
int sockmode __ARGS((int s,int mode));
void tflush __ARGS((void));
/* declared in global.h
	int tprintf __ARGS((const char *fmt,...));
 */
int tputc __ARGS((unsigned char c));
int getblock __ARGS((int s));
void traceprintf __ARGS((FILE *fp, const char *fmt, ...))
#ifdef UNIX
#ifdef __GNUC__
    __attribute__ ((format (printf, 2, 3)))
#endif
#endif
    ;
int tcmdprintf __ARGS((const char *fmt, ...))
#ifdef UNIX
#ifdef __GNUC__
    __attribute__ ((format (printf, 1, 2)))
#endif
    ;
int tfprintf __ARGS((FILE *fp, const char *fmt, ...))
#ifdef __GNUC__
    __attribute__ ((format (printf, 2, 3)))
#endif
#endif
    ;
int usflush __ARGS((int s));
int usprintf __ARGS((int s,const char *fmt,...));
int usputc __ARGS((int s,const unsigned char c));
int usputs __ARGS((int s,const char *x));
int usputbuf __ARGS((int s,const unsigned char *x, int len));
int usvprintf __ARGS((int s,const char *fmt, va_list args));	/*lint !e49 !e601 !e10 !e49 */
int nullsocket __ARGS((int s));

/* In file sockutil.c: */
char *psocket __ARGS((void *p));
const char *sockerr __ARGS((int s));
const char *sockstate __ARGS((int s));

/* In mailbox.c: */
extern char Nosock[];

#endif	/* _SOCKET_H */
