#ifndef _STATS_H
#define _STATS_H

#include "files.h"
#include "commands.h"
#include "socket.h"
#include "session.h"
#include "ctype.h"


#define MSPHOUR (1000L*60L*60L)
#define MSPDAY (1000L*60L*60L*24L)

#ifdef STATS_AREA
int doSTATclear_area __ARGS((int argc,char *argv[],void *p));
void loadstats_area __ARGS((void));
void savestats_area __ARGS((void));
void updatestats_area __ARGS((void));
int doSTATarea __ARGS((int argc,char *argv[],void *p));
void newhour_area __ARGS((int hour));
void newday_area __ARGS((int hour));
void endmonthclear_area __ARGS((int hour,int month));
void endday_area __ARGS((int hour));
void eachcycle_area __ARGS((time_t now));
void init_area __ARGS((time_t now));
int STATlist_area __ARGS((int argc,char *argv[],void *p));
#endif

#ifdef STATS_USE
extern long MiscUsers;
extern long localConfUsers;
extern int BbsUsers, FtpUsers, Tutored;
int doSTATclear_use __ARGS((int argc,char *argv[],void *p));
void loadstats_use __ARGS((void));
void savestats_use __ARGS((void));
void updatestats_use __ARGS((void));
int doSTATusage __ARGS((int argc,char *argv[],void *p));
void newhour_use __ARGS((int hour));
void newday_use __ARGS((int hour));
void endmonthclear_use __ARGS((int hour,int month));
void endday_use __ARGS((int hour));
void eachcycle_use __ARGS((time_t now));
void init_use __ARGS((time_t now));
#endif

#ifdef STATS_FWD
int doSTATclear_fwd __ARGS((int argc,char *argv[],void *p));
void loadstats_fwd __ARGS((void));
void savestats_fwd __ARGS((void));
void updatestats_fwd __ARGS((void));
int doSTATforward __ARGS((int argc,char *argv[],void *p));
void newhour_fwd __ARGS((int hour));
void newday_fwd __ARGS((int hour));
void endmonthclear_fwd __ARGS((int hour,int month));
void endday_fwd __ARGS((int hour));
void eachcycle_fwd __ARGS((time_t now));
void init_fwd __ARGS((time_t now));
int STATlist_fwd __ARGS((int argc,char *argv[],void *p));
#endif

#ifdef STATS_MSG
int doSTATclear_msg __ARGS((int argc,char *argv[],void *p));
void loadstats_msg __ARGS((void));
void savestats_msg __ARGS((void));
void updatestats_msg __ARGS((void));
int doSTATmessage __ARGS((int argc,char *argv[],void *p));
void newhour_msg __ARGS((int hour));
void newday_msg __ARGS((int hour));
void endmonthclear_msg __ARGS((int hour,int month));
void endday_msg __ARGS((int hour));
void eachcycle_msg __ARGS((time_t now));
void init_msg __ARGS((time_t now));
#endif

#ifdef STATS_TFC
int doSTATclear_tfc __ARGS((int argc,char *argv[],void *p));
void loadstats_tfc __ARGS((void));
void savestats_tfc __ARGS((void));
void updatestats_tfc __ARGS((void));
int doSTATtraffic __ARGS((int argc,char *argv[],void *p));
void newhour_tfc __ARGS((int hour));
void newday_tfc __ARGS((int hour));
void endmonthclear_tfc __ARGS((int hour,int month));
void endday_tfc __ARGS((int hour));
void eachcycle_tfc __ARGS((time_t now));
void init_tfc __ARGS((time_t now));
#endif

#if defined(STATS_USE) || defined(STATS_MSG) || defined(STATS_AREA) || defined(STATS_FWD) || defined(STATS_TFC)
void doGraph __ARGS((int num,long array[][2]));
#endif

#if defined(STATS_USE) || defined(STATS_MSG) || defined(STATS_TFC)
void loadstats __ARGS((const char *name,void *beginning, void *ending));
#endif

void saveastat __ARGS((FILE *fp,int num,long *data,const char *str));
void finishSavingStat __ARGS((FILE *fp, long *data));

extern const char DFAR dailyhdr[];
extern const char DFAR weeklyhdr[];
extern const char DFAR monthlyhdr[];
extern const char DFAR yearlyhdr[];
extern const char DFAR STAT_emptystr[];
extern const char DFAR STAT_dailytrailer[];
extern const char DFAR STAT_weeklytrailer[];
extern const char DFAR STAT_monthlytrailer[];
extern const char DFAR STAT_yearlytrailer[];
extern const char DFAR STAT_cannotclear[];

extern const char *Months[12];

#endif /* _STATS_H */
