/* UDP-related user commands
 * Copyright 1991 Phil Karn, KA9Q
 */
#include "global.h"
#include "commands.h"
#ifdef MSDOS
#include <dos.h>
#include "socket.h"
#endif
#include "mbuf.h"
#include "netuser.h"
#include "udp.h"

#if !defined(_lint) && !defined(MSDOS)
static char rcsid[] OPTIONAL = "$Id: udpcmd.c,v 1.11 1996/07/19 00:46:20 root Exp root $";
#endif

static int doudpstat __ARGS((int argc,char *argv[],void *p));

static struct cmds Udpcmds[] = {
	{ "status",	doudpstat,	0, 0,	NULLCHAR },
	{ NULLCHAR,	NULL,		0, 0,	NULLCHAR }
};


int
doudp (argc, argv, p)
int argc;
char *argv[];
void *p;
{
	return (subcmd (Udpcmds, argc, argv, p));
}


int
st_udp (udp, n)
struct udp_cb *udp;
int n;
{
	if (n == 0)
		tputs ("&UCB Rcv-Q  Local socket\n");
#ifdef UNIX
	return tprintf ("%8.8lx%6u  %s\n",
#else
	return tprintf ("%4.4x%6u  %s\n",
#endif
		FP_SEG(udp), udp->rcvcnt, pinet (&udp->socket));
}


/* Dump UDP statistics and control blocks */
static int
doudpstat (argc, argv, p)
int argc OPTIONAL;
char *argv[] OPTIONAL;
void *p OPTIONAL;
{
register struct udp_cb *udp;
register int i;

	for (i = 1; i <= NUMUDPMIB; i++)	{
		tprintf ("(%2u)%-20s%10lu", i, Udp_mib[i].name, Udp_mib[i].value.integer);
		if (i % 2)
			tputs("     ");
		else
			tputc('\n');
	}
	if ((i % 2) == 0)
		tputc('\n');

	tputs ("&UCB Rcv-Q  Local socket\n");
	for (udp = Udps; udp != NULLUDP; udp = udp->next)	{
		if (st_udp (udp, 1) == EOF)
			return 0;
	}
	return 0;
}
