#ifdef MSDOS

/* #define TEST 1 */
#ifdef TEST
#define LARGEDATA 1
#include <stdio.h>
#else
#include "global.h"
#endif

#include <dos.h>
#include <errno.h>
#include <alloc.h>

#if !defined(_lint) && !defined(MSDOS)
static char rcsid[] OPTIONAL = "$Id: umb.c,v 1.6 1996/06/22 18:20:37 root Exp root $";
#endif

#ifdef	LARGEDATA
#define	HUGE	huge
#else
#define	HUGE
#endif

#define XMSErrSmUMB 0xB0	/* Smaller UMB available */
#define MAXSIZE 0x0fff

extern int xms_init __ARGS((void));
extern int xms_allocUM __ARGS((short blockSize, void **address, short *actualSize));
extern int xms_freeUM __ARGS((void *address));


union header {
	struct {
		union header HUGE *ptr;
		unsigned long size;
	} s;
	long l[2];
};

typedef union header HEADER;
#define	ABLKSIZE	(sizeof (HEADER))
extern unsigned long Frees;	/* Total frees */
extern unsigned long Heapsize;

static void HUGE * umbs[100];
static short nextumb;
static long totalgain;
static void HUGE *lowUMB;


void
getUMBs(verbose)
int verbose;
{
HEADER HUGE *up;
unsigned nu;
short size;
long realsize, thissize = 0;
FILE *tempfiles[FOPEN_MAX];
int k;

	if (xms_init())	{
#ifdef TEST
		puts ("XMS Manager not found!");
#else
		log (-1, "XMS Manager not found!");
		if (verbose)
			tputs ("XMS Manager not found!\n");
#endif
		return;
	}
	
	for (k = 0; k < FOPEN_MAX; k++)	{
		tempfiles[k] = tmpfile();
		fwrite (tempfiles, sizeof (FILE *), FOPEN_MAX, tempfiles[k]);
	}
	for (k = 0; k < FOPEN_MAX; k++)
		if (tempfiles[k])
			fclose(tempfiles[k]);
	while (1)	{
		/* check for existance of an available UMB */
		errno = 0;
		xms_allocUM (MAXSIZE, (void far **)&up, (short far *)&size);
		if (errno != XMSErrSmUMB)
			break;	/* error, exit */
		if (size < 64)	/* is the block less than 1K? */
			break;	/* yep,  why bother! */

		/* Now get the largest block available */
		errno = 0;
		xms_allocUM (size, (void far **)&up, (short far *)&size);
		if (errno)
			break;

		/* add it to the list, so we can free it on exit */		
		umbs[nextumb++] = (void HUGE *)up;

		if (!lowUMB || up < lowUMB)
			lowUMB = up;
		realsize = (long)size * 16L;
		totalgain += realsize;
		thissize += realsize;
#ifdef TEST
		printf ("UMB paragraphs: %06d, size: %08ld, addr: %08lx\n", size, realsize, (void *)up);
#else
		log (-1, "UMB added - size: %08ld, addr: %08lx", realsize, (void *)up);
		nu = (size  * 16) / ABLKSIZE;
		up->s.size = nu;
		up->s.ptr = up; /* satisfy audit */
		free((void *)(up + 1));
		Heapsize += nu*ABLKSIZE;
		Frees--;	/* Nullify increment inside free() */
#endif
		if (nextumb == 100)	/* don't allow overflow of array */
			break;
	}
	if (thissize)	{
#ifdef TEST
		printf ("UMB total memory gained: %ld\n\n", thissize);
#else
		if (verbose)
			tprintf ("UMB total memory gained: %ld\n", thissize);
		log (-1, "UMB total memory gained: %ld", thissize);
#endif
	}
}

void
putUMBs()
{
int k;

	for (k = 0; k < nextumb; k++)
		xms_freeUM (umbs[k]);
	if (nextumb)
#ifdef TEST
		printf ("UMBs freed\n");
#else
		log (-1, "UMBs freed");
#endif
	nextumb = 0;
}

#ifndef TEST
void
umbstat ()
{
	tprintf ("UMBs: %d blocks, %ld bytes total memory increase\n", nextumb, totalgain);
}

int
isaUMB (HEADER HUGE *p)
{
int retval = 0;

	if (totalgain && nextumb)	{	/* only if UMBs have been allocated */
		if (p >= (HEADER HUGE *)lowUMB)
			retval = 1;
	}
	return (retval);
}


#if 0
int dohighwater (int argc,char *argv[],void *p)
{
	tprintf ("Highwater point between conventional memory and UMBs is 0x%08lx\n", (void *) lowUMB);
	return 0;
}
#endif
#else

void
main (void)
{

	setbuf (stdout, (char *)0);
	printf ("Getting UMBs....\n");
	getUMBs (1);
	printf ("\nFreeing UMBs....\n");
	putUMBs();
}
#endif /* TEST */
#endif /* MSDOS */
